# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetClusterResult',
    'AwaitableGetClusterResult',
    'get_cluster',
    'get_cluster_output',
]

@pulumi.output_type
class GetClusterResult:
    """
    A collection of values returned by getCluster.
    """
    def __init__(__self__, cloud_provider=None, db_instance_type=None, id=None, is_limited=None, k8s_tags=None, metadata=None, name=None, node_pools=None, organization_id=None, pod_subnet_range=None, provider_account=None, region=None, service_peering_range=None, service_subnet_range=None, tenant_id=None, type=None, vpc_subnet_range=None, workspace_ids=None):
        if cloud_provider and not isinstance(cloud_provider, str):
            raise TypeError("Expected argument 'cloud_provider' to be a str")
        pulumi.set(__self__, "cloud_provider", cloud_provider)
        if db_instance_type and not isinstance(db_instance_type, str):
            raise TypeError("Expected argument 'db_instance_type' to be a str")
        pulumi.set(__self__, "db_instance_type", db_instance_type)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if is_limited and not isinstance(is_limited, bool):
            raise TypeError("Expected argument 'is_limited' to be a bool")
        pulumi.set(__self__, "is_limited", is_limited)
        if k8s_tags and not isinstance(k8s_tags, list):
            raise TypeError("Expected argument 'k8s_tags' to be a list")
        pulumi.set(__self__, "k8s_tags", k8s_tags)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if node_pools and not isinstance(node_pools, list):
            raise TypeError("Expected argument 'node_pools' to be a list")
        pulumi.set(__self__, "node_pools", node_pools)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)
        if pod_subnet_range and not isinstance(pod_subnet_range, str):
            raise TypeError("Expected argument 'pod_subnet_range' to be a str")
        pulumi.set(__self__, "pod_subnet_range", pod_subnet_range)
        if provider_account and not isinstance(provider_account, str):
            raise TypeError("Expected argument 'provider_account' to be a str")
        pulumi.set(__self__, "provider_account", provider_account)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if service_peering_range and not isinstance(service_peering_range, str):
            raise TypeError("Expected argument 'service_peering_range' to be a str")
        pulumi.set(__self__, "service_peering_range", service_peering_range)
        if service_subnet_range and not isinstance(service_subnet_range, str):
            raise TypeError("Expected argument 'service_subnet_range' to be a str")
        pulumi.set(__self__, "service_subnet_range", service_subnet_range)
        if tenant_id and not isinstance(tenant_id, str):
            raise TypeError("Expected argument 'tenant_id' to be a str")
        pulumi.set(__self__, "tenant_id", tenant_id)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if vpc_subnet_range and not isinstance(vpc_subnet_range, str):
            raise TypeError("Expected argument 'vpc_subnet_range' to be a str")
        pulumi.set(__self__, "vpc_subnet_range", vpc_subnet_range)
        if workspace_ids and not isinstance(workspace_ids, list):
            raise TypeError("Expected argument 'workspace_ids' to be a list")
        pulumi.set(__self__, "workspace_ids", workspace_ids)

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> str:
        """
        The cluster's cloud provider.
        """
        return pulumi.get(self, "cloud_provider")

    @property
    @pulumi.getter(name="dbInstanceType")
    def db_instance_type(self) -> str:
        """
        The type of database instance that is used for the cluster. Required for Hybrid clusters.
        """
        return pulumi.get(self, "db_instance_type")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The cluster's identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isLimited")
    def is_limited(self) -> bool:
        """
        Whether the cluster is limited.
        """
        return pulumi.get(self, "is_limited")

    @property
    @pulumi.getter(name="k8sTags")
    def k8s_tags(self) -> Sequence['outputs.GetClusterK8sTagResult']:
        """
        The Kubernetes tags in the cluster.
        """
        return pulumi.get(self, "k8s_tags")

    @property
    @pulumi.getter
    def metadata(self) -> 'outputs.GetClusterMetadataResult':
        """
        The cluster's metadata.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The cluster's name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodePools")
    def node_pools(self) -> Sequence['outputs.GetClusterNodePoolResult']:
        """
        The list of node pools to create in the cluster.
        """
        return pulumi.get(self, "node_pools")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        """
        The organization this cluster is associated with.
        """
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter(name="podSubnetRange")
    def pod_subnet_range(self) -> str:
        """
        The subnet range for Pods. For GCP clusters only.
        """
        return pulumi.get(self, "pod_subnet_range")

    @property
    @pulumi.getter(name="providerAccount")
    def provider_account(self) -> str:
        """
        The provider account ID. Required for Hybrid clusters.
        """
        return pulumi.get(self, "provider_account")

    @property
    @pulumi.getter
    def region(self) -> str:
        """
        The cluster's region.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="servicePeeringRange")
    def service_peering_range(self) -> str:
        """
        The service peering range. For GCP clusters only.
        """
        return pulumi.get(self, "service_peering_range")

    @property
    @pulumi.getter(name="serviceSubnetRange")
    def service_subnet_range(self) -> str:
        """
        The service subnet range. For GCP clusters only.
        """
        return pulumi.get(self, "service_subnet_range")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> str:
        """
        The tenant ID. For Azure clusters only.
        """
        return pulumi.get(self, "tenant_id")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The cluster's type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="vpcSubnetRange")
    def vpc_subnet_range(self) -> str:
        """
        The VPC subnet range.
        """
        return pulumi.get(self, "vpc_subnet_range")

    @property
    @pulumi.getter(name="workspaceIds")
    def workspace_ids(self) -> Sequence[str]:
        """
        The list of Workspaces that are authorized to the cluster.
        """
        return pulumi.get(self, "workspace_ids")


class AwaitableGetClusterResult(GetClusterResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetClusterResult(
            cloud_provider=self.cloud_provider,
            db_instance_type=self.db_instance_type,
            id=self.id,
            is_limited=self.is_limited,
            k8s_tags=self.k8s_tags,
            metadata=self.metadata,
            name=self.name,
            node_pools=self.node_pools,
            organization_id=self.organization_id,
            pod_subnet_range=self.pod_subnet_range,
            provider_account=self.provider_account,
            region=self.region,
            service_peering_range=self.service_peering_range,
            service_subnet_range=self.service_subnet_range,
            tenant_id=self.tenant_id,
            type=self.type,
            vpc_subnet_range=self.vpc_subnet_range,
            workspace_ids=self.workspace_ids)


def get_cluster(id: Optional[str] = None,
                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetClusterResult:
    """
    Astronomer Cluster Data Source

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astronomer as astronomer

    imported_cluster = astronomer.get_cluster(id="clqoclq8201pp01p0cbt77feb")
    ```


    :param str id: The cluster's identifier.
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('astronomer:index/getCluster:getCluster', __args__, opts=opts, typ=GetClusterResult).value

    return AwaitableGetClusterResult(
        cloud_provider=pulumi.get(__ret__, 'cloud_provider'),
        db_instance_type=pulumi.get(__ret__, 'db_instance_type'),
        id=pulumi.get(__ret__, 'id'),
        is_limited=pulumi.get(__ret__, 'is_limited'),
        k8s_tags=pulumi.get(__ret__, 'k8s_tags'),
        metadata=pulumi.get(__ret__, 'metadata'),
        name=pulumi.get(__ret__, 'name'),
        node_pools=pulumi.get(__ret__, 'node_pools'),
        organization_id=pulumi.get(__ret__, 'organization_id'),
        pod_subnet_range=pulumi.get(__ret__, 'pod_subnet_range'),
        provider_account=pulumi.get(__ret__, 'provider_account'),
        region=pulumi.get(__ret__, 'region'),
        service_peering_range=pulumi.get(__ret__, 'service_peering_range'),
        service_subnet_range=pulumi.get(__ret__, 'service_subnet_range'),
        tenant_id=pulumi.get(__ret__, 'tenant_id'),
        type=pulumi.get(__ret__, 'type'),
        vpc_subnet_range=pulumi.get(__ret__, 'vpc_subnet_range'),
        workspace_ids=pulumi.get(__ret__, 'workspace_ids'))


@_utilities.lift_output_func(get_cluster)
def get_cluster_output(id: Optional[pulumi.Input[str]] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetClusterResult]:
    """
    Astronomer Cluster Data Source

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astronomer as astronomer

    imported_cluster = astronomer.get_cluster(id="clqoclq8201pp01p0cbt77feb")
    ```


    :param str id: The cluster's identifier.
    """
    ...
