# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetOrganizationResult',
    'AwaitableGetOrganizationResult',
    'get_organization',
    'get_organization_output',
]

@pulumi.output_type
class GetOrganizationResult:
    """
    A collection of values returned by getOrganization.
    """
    def __init__(__self__, billing_email=None, created_at=None, id=None, is_scim_enabled=None, managed_domains=None, name=None, payment_method=None, product=None, status=None, support_plan=None, trial_expires_at=None, updated_at=None):
        if billing_email and not isinstance(billing_email, str):
            raise TypeError("Expected argument 'billing_email' to be a str")
        pulumi.set(__self__, "billing_email", billing_email)
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if is_scim_enabled and not isinstance(is_scim_enabled, bool):
            raise TypeError("Expected argument 'is_scim_enabled' to be a bool")
        pulumi.set(__self__, "is_scim_enabled", is_scim_enabled)
        if managed_domains and not isinstance(managed_domains, list):
            raise TypeError("Expected argument 'managed_domains' to be a list")
        pulumi.set(__self__, "managed_domains", managed_domains)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if payment_method and not isinstance(payment_method, str):
            raise TypeError("Expected argument 'payment_method' to be a str")
        pulumi.set(__self__, "payment_method", payment_method)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)
        if support_plan and not isinstance(support_plan, str):
            raise TypeError("Expected argument 'support_plan' to be a str")
        pulumi.set(__self__, "support_plan", support_plan)
        if trial_expires_at and not isinstance(trial_expires_at, str):
            raise TypeError("Expected argument 'trial_expires_at' to be a str")
        pulumi.set(__self__, "trial_expires_at", trial_expires_at)
        if updated_at and not isinstance(updated_at, str):
            raise TypeError("Expected argument 'updated_at' to be a str")
        pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="billingEmail")
    def billing_email(self) -> str:
        """
        Billing email on file for the organization.
        """
        return pulumi.get(self, "billing_email")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Timestamped string of when this organization was created
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Organization's unique identifier
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isScimEnabled")
    def is_scim_enabled(self) -> bool:
        """
        Whether or not scim is enabled
        """
        return pulumi.get(self, "is_scim_enabled")

    @property
    @pulumi.getter(name="managedDomains")
    def managed_domains(self) -> Sequence['outputs.GetOrganizationManagedDomainResult']:
        """
        List of managed domains (nested)
        """
        return pulumi.get(self, "managed_domains")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Organization's name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="paymentMethod")
    def payment_method(self) -> Optional[str]:
        """
        Payment method (if set)
        """
        return pulumi.get(self, "payment_method")

    @property
    @pulumi.getter
    def product(self) -> str:
        """
        Type of astro product (e.g. hosted or hybrid)
        """
        return pulumi.get(self, "product")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Status of the organization
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="supportPlan")
    def support_plan(self) -> str:
        """
        Type of support plan the organization has
        """
        return pulumi.get(self, "support_plan")

    @property
    @pulumi.getter(name="trialExpiresAt")
    def trial_expires_at(self) -> str:
        """
        When the trial expires, if organization is in a trial
        """
        return pulumi.get(self, "trial_expires_at")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> str:
        """
        Last time the organization was updated
        """
        return pulumi.get(self, "updated_at")


class AwaitableGetOrganizationResult(GetOrganizationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrganizationResult(
            billing_email=self.billing_email,
            created_at=self.created_at,
            id=self.id,
            is_scim_enabled=self.is_scim_enabled,
            managed_domains=self.managed_domains,
            name=self.name,
            payment_method=self.payment_method,
            product=self.product,
            status=self.status,
            support_plan=self.support_plan,
            trial_expires_at=self.trial_expires_at,
            updated_at=self.updated_at)


def get_organization(id: Optional[str] = None,
                     payment_method: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrganizationResult:
    """
    Astronomer Organization Resource

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astronomer as astronomer

    test = astronomer.get_organization(id="abc123")
    ```


    :param str payment_method: Payment method (if set)
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['paymentMethod'] = payment_method
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('astronomer:index/getOrganization:getOrganization', __args__, opts=opts, typ=GetOrganizationResult).value

    return AwaitableGetOrganizationResult(
        billing_email=pulumi.get(__ret__, 'billing_email'),
        created_at=pulumi.get(__ret__, 'created_at'),
        id=pulumi.get(__ret__, 'id'),
        is_scim_enabled=pulumi.get(__ret__, 'is_scim_enabled'),
        managed_domains=pulumi.get(__ret__, 'managed_domains'),
        name=pulumi.get(__ret__, 'name'),
        payment_method=pulumi.get(__ret__, 'payment_method'),
        product=pulumi.get(__ret__, 'product'),
        status=pulumi.get(__ret__, 'status'),
        support_plan=pulumi.get(__ret__, 'support_plan'),
        trial_expires_at=pulumi.get(__ret__, 'trial_expires_at'),
        updated_at=pulumi.get(__ret__, 'updated_at'))


@_utilities.lift_output_func(get_organization)
def get_organization_output(id: Optional[pulumi.Input[str]] = None,
                            payment_method: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrganizationResult]:
    """
    Astronomer Organization Resource

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astronomer as astronomer

    test = astronomer.get_organization(id="abc123")
    ```


    :param str payment_method: Payment method (if set)
    """
    ...
